apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "passit.fullname" . }}-worker
  labels:
    {{- include "passit.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.worker.replicaCount }}
  selector:
    matchLabels:
      {{- include "passit.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        checksum/secret: {{ include (print $.Template.BasePath "/secrets.yaml") . | sha256sum }}
        checksum/configmap: {{ include (print $.Template.BasePath "/configmap.yaml") . | sha256sum }}
        tag: {{ .Values.image.tag }}
      labels:
        {{- include "passit.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          resources:
            {{- toYaml .Values.worker.resources | nindent 12 }}
          env:
            - name: DEBUG
              value: "False"
            - name: SERVER_ROLE
              value: "worker"
            {{- if .Values.redisURL }}
            - name: REDIS_URL
              value: {{ .Values.redisURL }}
            {{- end }}
            {{- if .Values.redis.enabled }}
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  key: redis-password
                  name: {{ include "passit.fullname" . }}-redis
            - name: REDIS_HOST
              value: {{ template "passit.redis.host" . }}
            - name: REDIS_PORT
              value: {{ template "passit.redis.port" . }}
            {{- end }}
          envFrom:
            - secretRef:
                name: {{ include "passit.fullname" . }}
            - configMapRef:
                name: {{ include "passit.fullname" . }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
